Index: sys/sys/priv.h
===================================================================
RCS file: sys/sys/priv.h
diff -N sys/sys/priv.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ sys/sys/priv.h	13 Sep 2006 08:59:50 -0000
@@ -0,0 +1,309 @@
+/*-
+ * Copyright (c) 2006 nCircle Network Security, Inc.
+ * All rights reserved.
+ *
+ * This software was developed by Robert N. M. Watson for the TrustedBSD
+ * Project under contract to nCircle Network Security, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR, NCIRCLE NETWORK SECURITY,
+ * INC., OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
+ * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+ * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+ * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+/*
+ * Privilege checking interface for BSD kernel.
+ */
+#ifndef _SYS_PRIV_H_
+#define	_SYS_PRIV_H_
+
+/*
+ * Privilege list.  In no particular order.
+ *
+ * Think carefully before adding or reusing one of these privileges -- are
+ * there existing instances referring to the same privilege?  Third party
+ * vendors may request the assignment of privileges to be used in loadable
+ * modules.  Particular numeric privilege assignments are part of the
+ * loadable kernel module ABI, and should not be changed across minor
+ * releases.
+ *
+ * When adding a new privilege, remember to determine if it's appropriate for
+ * use in jail, and update the privilege switch in kern_jail.c as necessary.
+ */
+enum priv {
+	/* Track beginning of privilege list. */
+	_PRIV_LOWEST,
+
+	/*
+	 * PRIV_ROOT is a catch-all for as yet unnamed privileges.  No new
+	 * references to this privilege should be added.
+	 */
+	PRIV_ROOT,		/* Catch-all during development. */
+
+	/*
+	 * The remaining privileges typically correspond to one or a small
+	 * number of specific privilege checks, and have (relatively) precise
+	 * meanings.  They are loosely sorted into a set of base system
+	 * privileges, such as the ability to reboot, and then loosely by
+	 * subsystem, indicated by a subsystem name.
+	 */
+	PRIV_ACCT,		/* Manage process accounting. */
+	PRIV_MAXFILES,		/* Exceed system open files limit. */
+	PRIV_MAXPROC,		/* Exceed system processes limit. */
+	PRIV_KTRACE,		/* Set/accept KTRFAC_ROOT on ktrace. */
+	PRIV_SETDUMPER,		/* Configure dump device (XXX: needs work). */
+	PRIV_NFSD,		/* Can become NFS daemon. */
+	PRIV_REBOOT,		/* Can reboot system. */
+	PRIV_SWAPON,		/* Can swapon(). */
+	PRIV_SWAPOFF,		/* Can swapoff(). */
+	PRIV_MSGBUF,		/* Can read kernel message buffer. */
+	PRIV_WITNESS,		/* Can configure WITNESS. */
+	PRIV_IO,		/* Can perform low-level I/O. */
+	PRIV_KEYBOARD,		/* Reprogram keyboard. */
+	PRIV_DRIVER,		/* Low-level driver privilege. */
+	PRIV_ADJTIME,		/* Set time adjustment. */
+	PRIV_NTP_ADJTIME,	/* Set NTP time adjustment. */
+	PRIV_CLOCK_SETTIME,	/* Can call clock_settime. */
+	PRIV_SETTIMEOFDAY,	/* Can call settimeofday. */
+	PRIV_SETHOSTID,		/* Can call sethostid. */
+	PRIV_SETDOMAINNAME,	/* Can call setdomainname. */
+	PRIV_AUDIT_CONTROL,	/* Can configure audit. */
+	PRIV_AUDIT_FAILSTOP,	/* Can run during audit fail stop. */
+	PRIV_AUDIT_GETAUDIT,	/* Can get proc audit properties. */
+	PRIV_AUDIT_SETAUDIT,	/* Can set proc audit properties. */
+	PRIV_AUDIT_SUBMIT,	/* Can submit an audit record. */
+	PRIV_CRED_SETUID,	/* setuid. */
+	PRIV_CRED_SETEUID,	/* seteuid to !ruid and !svuid. */
+	PRIV_CRED_SETGID,	/* setgid. */
+	PRIV_CRED_SETEGID,	/* setgid to !rgid and !svgid. */
+	PRIV_CRED_SETGROUPS,	/* Set process additional groups. */
+	PRIV_CRED_SETREUID,	/* setreuid. */
+	PRIV_CRED_SETREGID,	/* setregid. */
+	PRIV_CRED_SETRESUID,	/* setresuid. */
+	PRIV_CRED_SETRESGID,	/* setresgid. */
+	PRIV_SEEOTHERGIDS,	/* Exempt bsd.seeothergids. */
+	PRIV_SEEOTHERUIDS,	/* Exempt bsd.seeotheruids. */
+	PRIV_DEBUG_DIFFCRED,	/* Exempt debugging other users. */
+	PRIV_DEBUG_SUGID,	/* Exempt debugging setuid proc. */
+	PRIV_DEBUG_UNPRIV,	/* Exempt unprivileged debug limit. */
+	PRIV_FIRMWARE_LOAD,	/* Can load firmware. */
+	PRIV_JAIL_ATTACH,	/* Attach to a jail. */
+	PRIV_KENV_SET,		/* Set kernel env. variables. */
+	PRIV_KENV_UNSET,	/* Unset kernel env. variables. */
+	PRIV_KLD_LOAD,		/* Load a kernel module. */
+	PRIV_KLD_UNLOAD,	/* Unload a kernel module. */
+	PRIV_MAC_PARTITION,	/* Privilege in mac_partition policy. */
+	PRIV_MAC_PRIVS,		/* Privilege in the mac_privs policy. */
+	PRIV_PROC_LIMIT,	/* Exceed user process limit. */
+	PRIV_PROC_SETLOGIN,	/* Can call setlogin. */
+	PRIV_PROC_SETRLIMIT,	/* Can raise resources limits. */
+	PRIV_IPC_READ,		/* Can override IPC read perm. */
+	PRIV_IPC_WRITE,		/* Can override IPC write perm. */
+	PRIV_IPC_EXEC,		/* Can override IPC exec perm. */
+	PRIV_IPC_ADMIN,		/* Can override IPC owner-only perm. */
+	PRIV_IPC_MSGSIZE,	/* Exempt IPC message queue limit. */
+	PRIV_MQ_ADMIN,		/* Can override msgq owner-only perm. */
+	PRIV_PMC_MANAGE,	/* Can administer PMC. */
+	PRIV_PMC_SYSTEM,	/* Can allocate a system-wide PMC. */
+	PRIV_SCHED_DIFFCRED,	/* Exempt scheduling other users. */
+	PRIV_SCHED_SETPRIORITY,	/* Can set lower nice value for proc. */
+	PRIV_SCHED_RTPRIO,	/* Can set real time scheduling. */
+	PRIV_SCHED_SETPOLICY,	/* Can set scheduler policy. */
+	PRIV_SCHED_SET,		/* Can set thread scheduler. */
+	PRIV_SCHED_SETPARAM,	/* Can set thread scheduler params. */
+	PRIV_SEM_WRITE,		/* Can override sem write perm. */
+	PRIV_SIGNAL_DIFFCRED,	/* Exempt signalling other users. */
+	PRIV_SIGNAL_SUGID,	/* Non-conserv signal setuid proc. */
+	PRIV_SYSCTL_DEBUG,	/* Can invoke sysctl.debug. */
+	PRIV_SYSCTL_WRITE,	/* Can write sysctls. */
+	PRIV_SYSCTL_WRITEJAIL,	/* Can write sysctls, jail permitted. */
+	PRIV_TTY_CONSOLE,	/* Set console to tty. */
+	PRIV_TTY_DRAINWAIT,	/* Set tty drain wait time. */
+	PRIV_TTY_DTRWAIT,	/* Set DTR wait on tty. */
+	PRIV_TTY_EXCLUSIVE,	/* Override tty exclusive flag. */
+	PRIV_TTY_PRISON,	/* Can open pts across jails. */
+	PRIV_TTY_STI,		/* Simulate input on another tty. */
+	PRIV_TTY_SETA,		/* Set tty termios structure. */
+	PRIV_UFS_EXTATTRCTL,	/* Can configure EAs on UFS1. */
+	PRIV_UFS_GETQUOTA,	/* getquota(). */
+	PRIV_UFS_QUOTAOFF,	/* quotaoff(). */
+	PRIV_UFS_QUOTAON,	/* quotaon(). */
+	PRIV_UFS_SETQUOTA,	/* setquota(). */
+	PRIV_UFS_SETUSE,	/* setuse(). */
+	PRIV_UFS_EXCEEDQUOTA,	/* Exempt from quota restrictions. */
+	PRIV_VFS_READ,		/* Override vnode DAC read perm. */
+	PRIV_VFS_WRITE,		/* Override vnode DAC write perm. */
+	PRIV_VFS_ADMIN,		/* Override vnode DAC admin perm. */
+	PRIV_VFS_EXEC,		/* Override vnode DAC exec perm. */
+	PRIV_VFS_LOOKUP,	/* Override vnode DAC lookup perm. */
+	PRIV_VFS_BLOCKRESERVE,	/* Can use free block reserve. */
+	PRIV_VFS_CHFLAGS_DEV,	/* Can chflags() a device node. */
+	PRIV_VFS_CHOWN,		/* Can set user; group to non-member. */
+	PRIV_VFS_CHROOT,	/* chroot(). */
+	PRIV_VFS_CLEARSUGID,	/* Don't clear sugid on change. */
+	PRIV_VFS_EXTATTR_SYSTEM,	/* Operate on system EA namespace. */
+	PRIV_VFS_FCHROOT,	/* fchrot(). */
+	PRIV_VFS_FHOPEN,	/* Can fhopen(). */
+	PRIV_VFS_FHSTAT,	/* Can fhstat(). */
+	PRIV_VFS_FHSTATFS,	/* Can fhstatfs(). */
+	PRIV_VFS_GENERATION,	/* stat() returns generation number. */
+	PRIV_VFS_GETFH,		/* Can retrieve file handles. */
+	PRIV_VFS_LINK,		/* bsd.hardlink_check_uid */
+	PRIV_VFS_MKNOD_DEV,	/* Can create device nodes. */
+	PRIV_VFS_MOUNT,		/* Can mount(). */
+	PRIV_VFS_MOUNT_OWNER,	/* Override owner on user mounts. */
+	PRIV_VFS_MOUNT_EXPORTED,	/* Can set MNT_EXPORTED on mount. */
+	PRIV_VFS_MOUNT_PERM,	/* Override device node perms at mount. */
+	PRIV_VFS_MOUNT_SUIDDIR,	/* Can set MNT_SUIDDIR on mount. */
+	PRIV_VFS_SETGID,	/* Can setgid if not in group. */
+	PRIV_VFS_STICKYFILE,	/* Can set sticky bit on file. */
+	PRIV_VFS_SYSFLAGS,	/* Can modify system flags. */
+	PRIV_VFS_UNMOUNT,	/* Can unmount(). */
+	PRIV_VM_MADV_PROTECT,	/* Can set MADV_PROTECT. */
+	PRIV_VM_MLOCK,		/* Can mlock(), mlockall(). */
+	PRIV_VM_MUNLOCK,	/* Can munlock(), munlockall(). */
+	PRIV_DEVFS_RULE,	/* Can manage devfs rules. */
+	PRIV_DEVFS_SYMLINK,	/* Can create symlinks in devfs. */
+	PRIV_RANDOM_RESEED,	/* Closing /dev/random reseeds. */
+	PRIV_NET_BRIDGE,	/* Administer bridge. */
+	PRIV_NET_GRE,		/* Administer GRE. */
+	PRIV_NET_PPP,		/* Administer PPP. */
+	PRIV_NET_SLIP,		/* Administer SLIP. */
+	PRIV_NET_BPF,		/* Monitor BPF. */
+	PRIV_NET_RAW,		/* Open raw socket. */
+	PRIV_NET_ROUTE,		/* Administer routing. */
+	PRIV_NET_TAP,		/* Can open tap device. */
+	PRIV_NET_SETIFMTU,	/* Set interface MTU. */
+	PRIV_NET_SETIFFLAGS,	/* Set interface flags. */
+	PRIV_NET_SETIFCAP,	/* Set interface capabilities. */
+	PRIV_NET_SETIFNAME,	/* Set interface name. */
+	PRIV_NET_SETIFMETRIC,	/* Set interface metrics. */
+	PRIV_NET_SETIFPHYS,	/* Set interface physical layer prop. */
+	PRIV_NET_SETIFMAC,	/* Set interface MAC label. */
+	PRIV_NET_ADDMULTI,	/* Add multicast addr. to ifnet. */
+	PRIV_NET_DELMULTI,	/* Delete multicast addr. from ifnet. */
+	PRIV_NET_HWIOCTL,	/* Issue hardware ioctl on ifnet. */
+	PRIV_NET_SETLLADDR,
+	PRIV_NET_ADDIFGROUP,	/* Add new interface group. */
+	PRIV_NET_DELIFGROUP,	/* Delete interface group. */
+	PRIV_NET_IFCREATE,	/* Create cloned interface. */
+	PRIV_NET_IFDESTROY,	/* Destroy cloned interface. */
+	PRIV_NET80211_GETKEY,	/* Query 802.11 keys. */
+	PRIV_NET80211_MANAGE,	/* Administer 802.11. */
+	PRIV_NETATALK_RESERVEDPORT,	/* Bind low port number. */
+	PRIV_NETATM_CFG,
+	PRIV_NETATM_ADD,
+	PRIV_NETATM_DEL,
+	PRIV_NETATM_SET,
+	PRIV_NETGRAPH_CONTROL,	/* Open netgraph control socket. */
+	PRIV_NETGRAPH_TTY,	/* Configure tty for netgraph. */
+	PRIV_NETINET_RESERVEDPORT,	/* Bind low port number. */
+	PRIV_NETINET_IPFW,	/* Administer IPFW firewall. */
+	PRIV_NETINET_DIVERT,	/* Open IP divert socket. */
+	PRIV_NETINET_PF,	/* Administer pf firewall. */
+	PRIV_NETINET_DUMMYNET,	/* Administer DUMMYNET. */
+	PRIV_NETINET_CARP,	/* Administer CARP. */
+	PRIV_NETINET_MROUTE,	/* Administer multicast routing. */
+	PRIV_NETINET_RAW,	/* Open netinet raw socket. */
+	PRIV_NETINET_GETCRED,	/* Query netinet pcb credentials. */
+	PRIV_NETINET_ADDRCTRL6,	/* Administer IPv6 address scopes. */
+	PRIV_NETINET_ND6,	/* Administer IPv6 neighbor disc. */
+	PRIV_NETINET_SCOPE6,	/* Administer IPv6 address scopes. */
+	PRIV_NETINET_ALIFETIME6,	/* Administer IPv6 address lifetimes. */
+	PRIV_NETINET_IPSEC,	/* Administer IPSEC. */
+	PRIV_NETIPX_RESERVEDPORT,	/* Bind low port number. */
+	PRIV_NETIPX_RAW,	/* Open netipx raw socket. */
+	PRIV_NETNCP,	/* Allow use of connection owned by another user. */
+	PRIV_NETSMB,	/* Allow use of connection owned by another user. */
+	PRIV_VM86_INTCALL,	/* Allow invoking vm86 int handlers. */
+
+	/*
+	 * Set of reserved privilege values, which will be allocated to code
+	 * as needed, in order to avoid renumbering later privileges due to
+	 * insertion.
+	 */
+	_PRIV_RESERVED0,
+	_PRIV_RESERVED1,
+	_PRIV_RESERVED2,
+	_PRIV_RESERVED3,
+	_PRIV_RESERVED4,
+	_PRIV_RESERVED5,
+	_PRIV_RESERVED6,
+	_PRIV_RESERVED7,
+	_PRIV_RESERVED8,
+	_PRIV_RESERVED9,
+	_PRIV_RESERVED10,
+	_PRIV_RESERVED11,
+	_PRIV_RESERVED12,
+	_PRIV_RESERVED13,
+	_PRIV_RESERVED14,
+	_PRIV_RESERVED15,
+
+	/*
+	 * Define a set of valid privilege numbers that can be used by
+	 * loadable modules that don't yet have privilege reservations.
+	 * Ideally, these should not be used, since their meaning is opaque
+	 * to any policies that are aware of specific privileges, such as
+	 * jail, and as such may be arbitrarily denied.
+	 */
+	PRIV_MODULE0,
+	PRIV_MODULE1,
+	PRIV_MODULE2,
+	PRIV_MODULE3,
+	PRIV_MODULE4,
+	PRIV_MODULE5,
+	PRIV_MODULE6,
+	PRIV_MODULE7,
+	PRIV_MODULE8,
+	PRIV_MODULE9,
+	PRIV_MODULE10,
+	PRIV_MODULE11,
+	PRIV_MODULE12,
+	PRIV_MODULE13,
+	PRIV_MODULE14,
+	PRIV_MODULE15,
+
+	/* Track end of privilege list. */
+	_PRIV_HIGHEST
+};
+
+/*
+ * Validate that a named privilege is known by the privilege system.  Invalid
+ * privileges presented to the privilege system by a priv_check interface
+ * will result in a panic.
+ */
+#define	PRIV_VALID(x)	((x) > _PRIV_LOWEST && (x) < _PRIV_HIGHEST)
+
+#ifdef _KERNEL
+/*
+ * Privilege check interfaces, modeled after historic suser() interfacs, but
+ * with the addition of a specific privilege name.  The existing SUSER_* flag
+ * name space is used here.  The jail flag will likely be something that can
+ * be removed at some point as jail itself will be able to decide if the priv
+ * is appropriate, rather than the caller.
+ */
+struct thread;
+struct ucred;
+int	priv_check(struct thread *td, enum priv priv);
+int	priv_check_cred(struct ucred *cred, enum priv priv, int flags);
+#endif
+
+#endif /* !_SYS_PRIV_H_ */
Index: sys/sys/sysctl.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/sysctl.h,v
retrieving revision 1.144
diff -u -r1.144 sysctl.h
--- sys/sys/sysctl.h	21 Aug 2006 06:27:27 -0000	1.144
+++ sys/sys/sysctl.h	13 Sep 2006 08:56:40 -0000
@@ -628,6 +628,8 @@
 SYSCTL_DECL(_user);
 SYSCTL_DECL(_compat);
 SYSCTL_DECL(_regression);
+SYSCTL_DECL(_security);
+SYSCTL_DECL(_security_bsd);
 
 extern char	machine[];
 extern char	osrelease[];
Index: sys/sys/systm.h
===================================================================
RCS file: /home/ncvs/src/sys/sys/systm.h,v
retrieving revision 1.243
diff -u -r1.243 systm.h
--- sys/sys/systm.h	28 Aug 2006 02:28:14 -0000	1.243
+++ sys/sys/systm.h	13 Sep 2006 08:56:40 -0000
@@ -230,7 +230,7 @@
 #define SUSER_RUID	2
 
 int	suser(struct thread *td);
-int	suser_cred(struct ucred *cred, int flag);
+int	suser_cred(struct ucred *cred, int flags);
 int	cr_cansee(struct ucred *u1, struct ucred *u2);
 int	cr_canseesocket(struct ucred *cred, struct socket *so);
 
Index: sys/ufs/ffs/ffs_alloc.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_alloc.c,v
retrieving revision 1.140
diff -u -r1.140 ffs_alloc.c
--- sys/ufs/ffs/ffs_alloc.c	18 Jul 2006 07:03:43 -0000	1.140
+++ sys/ufs/ffs/ffs_alloc.c	13 Sep 2006 08:56:40 -0000
@@ -71,6 +71,7 @@
 #include <sys/conf.h>
 #include <sys/file.h>
 #include <sys/filedesc.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/vnode.h>
 #include <sys/mount.h>
@@ -171,7 +172,7 @@
 #endif
 	if (size == fs->fs_bsize && fs->fs_cstotal.cs_nbfree == 0)
 		goto nospace;
-	if (suser_cred(cred, SUSER_ALLOWJAIL) &&
+	if (priv_check_cred(cred, PRIV_VFS_BLOCKRESERVE, SUSER_ALLOWJAIL) &&
 	    freespace(fs, fs->fs_minfree) - numfrags(fs, size) < 0)
 		goto nospace;
 	if (bpref >= fs->fs_size)
@@ -259,7 +260,7 @@
 #endif /* DIAGNOSTIC */
 	reclaimed = 0;
 retry:
-	if (suser_cred(cred, SUSER_ALLOWJAIL) &&
+	if (priv_check_cred(cred, PRIV_VFS_BLOCKRESERVE, SUSER_ALLOWJAIL) &&
 	    freespace(fs, fs->fs_minfree) -  numfrags(fs, nsize - osize) < 0) {
 		goto nospace;
 	}
Index: sys/ufs/ffs/ffs_vfsops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_vfsops.c,v
retrieving revision 1.318
diff -u -r1.318 ffs_vfsops.c
--- sys/ufs/ffs/ffs_vfsops.c	9 Jul 2006 14:11:09 -0000	1.318
+++ sys/ufs/ffs/ffs_vfsops.c	13 Sep 2006 08:56:40 -0000
@@ -40,6 +40,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/namei.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/kernel.h>
 #include <sys/mac.h>
@@ -248,15 +249,16 @@
 			 * If upgrade to read-write by non-root, then verify
 			 * that user has necessary permissions on the device.
 			 */
-			if (suser(td)) {
-				vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
-				if ((error = VOP_ACCESS(devvp, VREAD | VWRITE,
-				    td->td_ucred, td)) != 0) {
-					VOP_UNLOCK(devvp, 0, td);
-					return (error);
-				}
+			vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+			error = VOP_ACCESS(devvp, VREAD | VWRITE,
+			    td->td_ucred, td);
+			if (error)
+				error = priv_check(td, PRIV_VFS_MOUNT_PERM);
+			if (error) {
 				VOP_UNLOCK(devvp, 0, td);
+				return (error);
 			}
+			VOP_UNLOCK(devvp, 0, td);
 			fs->fs_flags &= ~FS_UNCLEAN;
 			if (fs->fs_clean == 0) {
 				fs->fs_flags |= FS_UNCLEAN;
@@ -345,14 +347,15 @@
 	 * If mount by non-root, then verify that user has necessary
 	 * permissions on the device.
 	 */
-	if (suser(td)) {
-		accessmode = VREAD;
-		if ((mp->mnt_flag & MNT_RDONLY) == 0)
-			accessmode |= VWRITE;
-		if ((error = VOP_ACCESS(devvp, accessmode, td->td_ucred, td))!= 0){
-			vput(devvp);
-			return (error);
-		}
+	accessmode = VREAD;
+	if ((mp->mnt_flag & MNT_RDONLY) == 0)
+		accessmode |= VWRITE;
+	error = VOP_ACCESS(devvp, accessmode, td->td_ucred, td);
+	if (error)
+		error = priv_check(td, PRIV_VFS_MOUNT_PERM);
+	if (error) {
+		vput(devvp);
+		return (error);
 	}
 
 	if (mp->mnt_flag & MNT_UPDATE) {
Index: sys/ufs/ffs/ffs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ffs/ffs_vnops.c,v
retrieving revision 1.160
diff -u -r1.160 ffs_vnops.c
--- sys/ufs/ffs/ffs_vnops.c	5 May 2006 19:58:36 -0000	1.160
+++ sys/ufs/ffs/ffs_vnops.c	13 Sep 2006 08:56:40 -0000
@@ -74,6 +74,7 @@
 #include <sys/limits.h>
 #include <sys/malloc.h>
 #include <sys/mount.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/resourcevar.h>
 #include <sys/signalvar.h>
@@ -778,7 +779,8 @@
 	 * tampering.
 	 */
 	if (resid > uio->uio_resid && ap->a_cred && 
-	    suser_cred(ap->a_cred, SUSER_ALLOWJAIL)) {
+	    priv_check_cred(ap->a_cred, PRIV_VFS_CLEARSUGID,
+	    SUSER_ALLOWJAIL)) {
 		ip->i_mode &= ~(ISUID | ISGID);
 		DIP_SET(ip, i_mode, ip->i_mode);
 	}
@@ -1101,7 +1103,7 @@
 	 * tampering.
 	 */
 	if (resid > uio->uio_resid && ucred && 
-	    suser_cred(ucred, SUSER_ALLOWJAIL)) {
+	    priv_check_cred(ucred, PRIV_VFS_CLEARSUGID, SUSER_ALLOWJAIL)) {
 		ip->i_mode &= ~(ISUID | ISGID);
 		dp->di_mode = ip->i_mode;
 	}
Index: sys/ufs/ufs/ufs_extattr.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_extattr.c,v
retrieving revision 1.84
diff -u -r1.84 ufs_extattr.c
--- sys/ufs/ufs/ufs_extattr.c	1 Feb 2006 00:25:26 -0000	1.84
+++ sys/ufs/ufs/ufs_extattr.c	13 Sep 2006 08:56:40 -0000
@@ -48,6 +48,7 @@
 #include <sys/namei.h>
 #include <sys/malloc.h>
 #include <sys/fcntl.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/vnode.h>
 #include <sys/mount.h>
@@ -699,7 +700,8 @@
 	 * Processes with privilege, but in jail, are not allowed to
 	 * configure extended attributes.
 	 */
-	if ((error = suser(td))) {
+	error = priv_check(td, PRIV_UFS_EXTATTRCTL);
+	if (error) {
 		if (filename_vp != NULL)
 			VOP_UNLOCK(filename_vp, 0, td);
 		return (error);
Index: sys/ufs/ufs/ufs_quota.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_quota.c,v
retrieving revision 1.82
diff -u -r1.82 ufs_quota.c
--- sys/ufs/ufs/ufs_quota.c	5 May 2006 20:10:04 -0000	1.82
+++ sys/ufs/ufs/ufs_quota.c	13 Sep 2006 08:56:40 -0000
@@ -46,6 +46,7 @@
 #include <sys/mount.h>
 #include <sys/mutex.h>
 #include <sys/namei.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/socket.h>
 #include <sys/stat.h>
@@ -58,8 +59,6 @@
 #include <ufs/ufs/ufsmount.h>
 #include <ufs/ufs/ufs_extern.h>
 
-SYSCTL_DECL(_security_bsd);
-
 static int unprivileged_get_quota = 0;
 SYSCTL_INT(_security_bsd, OID_AUTO, unprivileged_get_quota, CTLFLAG_RW,
     &unprivileged_get_quota, 0,
@@ -167,7 +166,8 @@
 		}
 		return (0);
 	}
-	if ((flags & FORCE) == 0 && suser_cred(cred, 0)) {
+	if ((flags & FORCE) == 0 && priv_check_cred(cred,
+	    PRIV_UFS_EXCEEDQUOTA, 0)) {
 		for (i = 0; i < MAXQUOTAS; i++) {
 			if ((dq = ip->i_dquot[i]) == NODQUOT)
 				continue;
@@ -290,7 +290,8 @@
 		}
 		return (0);
 	}
-	if ((flags & FORCE) == 0 && suser_cred(cred, 0)) {
+	if ((flags & FORCE) == 0 && priv_check_cred(cred,
+	    PRIV_UFS_EXCEEDQUOTA, 0)) {
 		for (i = 0; i < MAXQUOTAS; i++) {
 			if ((dq = ip->i_dquot[i]) == NODQUOT)
 				continue;
@@ -425,7 +426,11 @@
 	int error, flags;
 	struct nameidata nd;
 
-	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+	/*
+	 * XXXRW: Can this be right?  Jail is allowed to do this?
+	 */
+	error = priv_check_cred(td->td_ucred, PRIV_UFS_QUOTAON,
+	    SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
 
@@ -517,7 +522,11 @@
 	struct inode *ip;
 	int error;
 
-	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+	/*
+	 * XXXRW: This also seems wrong to allow in a jail?
+	 */
+	error = priv_check_cred(td->td_ucred, PRIV_UFS_QUOTAOFF,
+	    SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
 
@@ -586,15 +595,18 @@
 	switch (type) {
 	case USRQUOTA:
 		if ((td->td_ucred->cr_uid != id) && !unprivileged_get_quota) {
-			error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+			error = priv_check_cred(td->td_ucred,
+			    PRIV_UFS_GETQUOTA, SUSER_ALLOWJAIL);
 			if (error)
 				return (error);
 		}
 		break;  
 
 	case GRPQUOTA:
-		if (!groupmember(id, td->td_ucred) && !unprivileged_get_quota) {
-			error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+		if (!groupmember(id, td->td_ucred) &&
+		    !unprivileged_get_quota) {
+			error = priv_check_cred(td->td_ucred,
+			    PRIV_UFS_GETQUOTA, SUSER_ALLOWJAIL);
 			if (error)
 				return (error);
 		}
@@ -629,7 +641,8 @@
 	struct dqblk newlim;
 	int error;
 
-	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+	error = priv_check_cred(td->td_ucred, PRIV_UFS_SETQUOTA,
+	    SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
 
@@ -695,7 +708,8 @@
 	struct dqblk usage;
 	int error;
 
-	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
+	error = priv_check_cred(td->td_ucred, PRIV_UFS_SETUSE,
+	    SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
 
Index: sys/ufs/ufs/ufs_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/ufs/ufs/ufs_vnops.c,v
retrieving revision 1.278
diff -u -r1.278 ufs_vnops.c
--- sys/ufs/ufs/ufs_vnops.c	20 Aug 2006 10:52:44 -0000	1.278
+++ sys/ufs/ufs/ufs_vnops.c	13 Sep 2006 08:56:40 -0000
@@ -53,6 +53,7 @@
 #include <sys/bio.h>
 #include <sys/buf.h>
 #include <sys/mount.h>
+#include <sys/priv.h>
 #include <sys/refcount.h>
 #include <sys/unistd.h>
 #include <sys/vnode.h>
@@ -465,8 +466,11 @@
 		 * processes if the security.jail.chflags_allowed sysctl is
 		 * is non-zero; otherwise, they behave like unprivileged
 		 * processes.
+		 *
+		 * XXXRW: Move implementation of jail_chflags_allowed to
+		 * kern_jail.c.
 		 */
-		if (!suser_cred(cred,
+		if (!priv_check_cred(cred, PRIV_VFS_SYSFLAGS,
 		    jail_chflags_allowed ? SUSER_ALLOWJAIL : 0)) {
 			if (ip->i_flags
 			    & (SF_NOUNLINK | SF_IMMUTABLE | SF_APPEND)) {
@@ -557,10 +561,19 @@
 		 * super-user.
 		 * If times is non-NULL, ... The caller must be the owner of
 		 * the file or be the super-user.
+		 *
+		 * Possibly for historical reasons, try to use VADMIN in
+		 * preference to VADMIN for a NULL timestamp.  This means we
+		 * will return EACCES in preference to EPERM if neither
+		 * check succeeds.
 		 */
-		if ((error = VOP_ACCESS(vp, VADMIN, cred, td)) &&
-		    ((vap->va_vaflags & VA_UTIMES_NULL) == 0 ||
-		    (error = VOP_ACCESS(vp, VWRITE, cred, td))))
+		if (vap->va_vaflags & VA_UTIMES_NULL) {
+			error = VOP_ACCESS(vp, VADMIN, cred, td);
+			if (error)
+				error = VOP_ACCESS(vp, VWRITE, cred, td);
+		} else
+			error = VOP_ACCESS(vp, VADMIN, cred, td);
+		if (error)
 			return (error);
 		if (vap->va_atime.tv_sec != VNOVAL)
 			ip->i_flag |= IN_ACCESS;
@@ -626,11 +639,13 @@
 	 * jail(8).
 	 */
 	if (vp->v_type != VDIR && (mode & S_ISTXT)) {
-		if (suser_cred(cred, SUSER_ALLOWJAIL))
+		if (priv_check_cred(cred, PRIV_VFS_STICKYFILE,
+		    SUSER_ALLOWJAIL))
 			return (EFTYPE);
 	}
 	if (!groupmember(ip->i_gid, cred) && (mode & ISGID)) {
-		error = suser_cred(cred, SUSER_ALLOWJAIL);
+		error = priv_check_cred(cred, PRIV_VFS_SETGID,
+		    SUSER_ALLOWJAIL);
 		if (error)
 			return (error);
 	}
@@ -667,19 +682,19 @@
 	if (gid == (gid_t)VNOVAL)
 		gid = ip->i_gid;
 	/*
-	 * To modify the ownership of a file, must possess VADMIN
-	 * for that file.
+	 * To modify the ownership of a file, must possess VADMIN for that
+	 * file.
 	 */
 	if ((error = VOP_ACCESS(vp, VADMIN, cred, td)))
 		return (error);
 	/*
-	 * To change the owner of a file, or change the group of a file
-	 * to a group of which we are not a member, the caller must
-	 * have privilege.
+	 * To change the owner of a file, or change the group of a file to a
+	 * group of which we are not a member, the caller must have
+	 * privilege.
 	 */
 	if ((uid != ip->i_uid || 
 	    (gid != ip->i_gid && !groupmember(gid, cred))) &&
-	    (error = suser_cred(cred, SUSER_ALLOWJAIL)))
+	    (error = priv_check_cred(cred, PRIV_VFS_CHOWN, SUSER_ALLOWJAIL)))
 		return (error);
 	ogid = ip->i_gid;
 	ouid = ip->i_uid;
@@ -750,7 +765,8 @@
 		panic("ufs_chown: lost quota");
 #endif /* QUOTA */
 	ip->i_flag |= IN_CHANGE;
-	if (suser_cred(cred, SUSER_ALLOWJAIL) && (ouid != uid || ogid != gid)) {
+	if (priv_check_cred(cred, PRIV_VFS_CLEARSUGID, SUSER_ALLOWJAIL) &&
+	    (ouid != uid || ogid != gid)) {
 		ip->i_mode &= ~(ISUID | ISGID);
 		DIP_SET(ip, i_mode, ip->i_mode);
 	}
@@ -2321,7 +2337,8 @@
 	if (DOINGSOFTDEP(tvp))
 		softdep_change_linkcnt(ip);
 	if ((ip->i_mode & ISGID) && !groupmember(ip->i_gid, cnp->cn_cred) &&
-	    suser_cred(cnp->cn_cred, SUSER_ALLOWJAIL)) {
+	    priv_check_cred(cnp->cn_cred, PRIV_VFS_SETGID,
+	    SUSER_ALLOWJAIL)) {
 		ip->i_mode &= ~ISGID;
 		DIP_SET(ip, i_mode, ip->i_mode);
 	}
Index: sys/vm/swap_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/swap_pager.c,v
retrieving revision 1.282
diff -u -r1.282 swap_pager.c
--- sys/vm/swap_pager.c	9 Aug 2006 17:43:27 -0000	1.282
+++ sys/vm/swap_pager.c	13 Sep 2006 08:56:40 -0000
@@ -77,6 +77,7 @@
 #include <sys/systm.h>
 #include <sys/conf.h>
 #include <sys/kernel.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/bio.h>
 #include <sys/buf.h>
@@ -1965,11 +1966,11 @@
 	struct nameidata nd;
 	int error;
 
-	mtx_lock(&Giant);
-	error = suser(td);
+	error = priv_check(td, PRIV_SWAPON);
 	if (error)
-		goto done2;
+		return (error);
 
+	mtx_lock(&Giant);
 	while (swdev_syscall_active)
 	    tsleep(&swdev_syscall_active, PUSER - 1, "swpon", 0);
 	swdev_syscall_active = 1;
@@ -2008,7 +2009,6 @@
 done:
 	swdev_syscall_active = 0;
 	wakeup_one(&swdev_syscall_active);
-done2:
 	mtx_unlock(&Giant);
 	return (error);
 }
@@ -2104,7 +2104,7 @@
 	struct swdevt *sp;
 	int error;
 
-	error = suser(td);
+	error = priv_check(td, PRIV_SWAPOFF);
 	if (error)
 		return (error);
 
Index: sys/vm/vm_mmap.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_mmap.c,v
retrieving revision 1.206
diff -u -r1.206 vm_mmap.c
--- sys/vm/vm_mmap.c	21 Jun 2006 12:59:05 -0000	1.206
+++ sys/vm/vm_mmap.c	13 Sep 2006 08:56:40 -0000
@@ -54,6 +54,7 @@
 #include <sys/mutex.h>
 #include <sys/sysproto.h>
 #include <sys/filedesc.h>
+#include <sys/priv.h>
 #include <sys/proc.h>
 #include <sys/resource.h>
 #include <sys/resourcevar.h>
@@ -683,7 +684,7 @@
 	 * "immortal."
 	 */
 	if (uap->behav == MADV_PROTECT) {
-		error = suser(td);
+		error = priv_check(td, PRIV_VM_MADV_PROTECT);
 		if (error == 0) {
 			p = td->td_proc;
 			PROC_LOCK(p);
@@ -950,7 +951,7 @@
 	vm_size_t npages, size;
 	int error;
 
-	error = suser(td);
+	error = priv_check(td, PRIV_VM_MLOCK);
 	if (error)
 		return (error);
 	addr = (vm_offset_t)uap->addr;
@@ -1015,7 +1016,7 @@
 	}
 	PROC_UNLOCK(td->td_proc);
 #else
-	error = suser(td);
+	error = priv_check(td, PRIV_VM_MLOCK);
 	if (error)
 		return (error);
 #endif
@@ -1060,7 +1061,7 @@
 	int error;
 
 	map = &td->td_proc->p_vmspace->vm_map;
-	error = suser(td);
+	error = priv_check(td, PRIV_VM_MUNLOCK);
 	if (error)
 		return (error);
 
@@ -1094,7 +1095,7 @@
 	vm_size_t size;
 	int error;
 
-	error = suser(td);
+	error = priv_check(td, PRIV_VM_MUNLOCK);
 	if (error)
 		return (error);
 	addr = (vm_offset_t)uap->addr;
